#!/usr/local/gesa/phpcli/bin/php
<?php

//on va lire l'endroit ou se trouve le fichier de configuratuin du client
$options = getopt("f:DU:");
//on test si on a renseigné un fichier de configuration
if(isset($options["f"]) && !empty($options["f"]))
{
	//on inclus le fichier de conf
	include $options["f"];
}
else
{
	//pas de fichier de conf on quitte l'application
	echo "CONFIG FILE NO FOUND \n";
	print_help();
	exit(1);
}

include_once 'libs/PoolThread.class.php';
include_once 'libs/ThAlive.class.php';
include_once 'libs/Task.class.php';
include_once 'libs/ECATP.class.php';
include_once 'libs/EventManager.class.php';

//EVENT MANAGER
$EVM=new EventManager();


//TABLEAU GLOBAL d'EXECUTION
$EXEC_ARRAY=array();
//Variable de FIN d'execution
$ENDCLIENT = 0;
//CREATION DU GARBAGE 
$_GLOBALS["GARBAGE"]=array();
// l'usage des ticks est nécessaire depuis PHP 4.3.0
declare(ticks = 1);

//on vérifie si on est en mode DEBUG
if(isset($options["D"]))
{
	//mode Debug ON
	$EVM->addEventListener(new fileLogger("gesa_client.log",LOG_PATH,false),E_USER_NOTICE);
	$EVM->addEventListener(new stdoutLogger());
}
else
{
	//mode Debug OFF
	$EVM->addEventListener(new fileLogger("gesa_client.log",LOG_PATH,false),E_USER_WARNING);
}
$EVM->notify("ECATP-CLIENT START",E_USER_NOTICE);

$CONNECT=array();
//si on a spécifié l'URL, on l'indique dans l'array de connexion
if(isset($options["U"]) && !empty($options["U"]))
{
	$CONNECT["URL"] = $options["U"];
}
else 
{
	//sinon on utilise une constante HOST et PORT 
	$CONNECT = array('HOST'=>HOST,'PORT'=>PORT );
}
//Lecture du numéros de série de la GESA
$SN = getGESASN();
if(empty($SN))
{
	//pas de numéros de série arret de la gesa
	$EVM->notify("No GESA Serial number, file no found or empty",E_USER_ERROR);
	//ERREUR LE TABLEAU n'as pu être crée on ferme l'application.
	echo "No GESA Serial number, file no found or empty\n";
	exit(1);
}

//CREATION DU TABLEAU LISTANT LES PLUGINS
$LIST_PLUGINS = array();
if(is_file(LIST_PLUGINS))
{
	//on ouvre le fichier
	$file = fopen(LIST_PLUGINS, 'r');
	while (($buffer = fgets($file)) !== false) 
	{
		if(!empty($buffer)) //si la ligne est vide on ne l'ajoute pas
		{
			//on nettoie la chaine et on l'ajoute à LIST_PLUGINS
			$LIST_PLUGINS[] = trim($buffer);
		}
	}
	//test si on a bien atteint la fin du fichier sinon une erreur sait produite
	if (!feof($file)) 
	{
		$EVM->notify("File of list plugin: error fgets() ",E_USER_ERROR);
		fclose($file);
		exit(1);
	}
	fclose($file);
}
else
{
	$EVM->notify("File of list plugins no found",E_USER_ERROR);
	//ERREUR LE TABLEAU n'as pu être crée on ferme l'application.
	echo "FILE LIST plugin no found\n";
	exit(1);
}
print_r($LIST_PLUGINS);
//
//CREATION DU TABLEAU d'EXECUTION
//

if(is_dir(EXEC_DIRECTORY))
{
	$EVM->notify("repertoire trouvé\n".EXEC_DIRECTORY,E_USER_NOTICE);
	if ($dh = opendir(EXEC_DIRECTORY)) 
	{
		$EVM->notify("OUVERTURE REUSSI: on liste les fichiers",E_USER_NOTICE);
		while (($file = readdir($dh)) !== false) 
		{
			//Trace("fichier : |$file| : type : " . filetype(EXEC_DIRECTORY . $file));
			if(is_executable(EXEC_DIRECTORY.$file))
			{
				//on list les fichiers et on crée le tableau d'execution
				if(array_search($file, $LIST_PLUGINS)!==FALSE)
				{
					$EVM->notify("\tfichier : $file FOUND!!!!!!!",E_USER_NOTICE);
					$EXEC_ARRAY[$file] = SUDO_PATH." ".EXEC_DIRECTORY.$file;
				}
			}
		}
		$EVM->notify("FERMETURE REUSSI",E_USER_NOTICE);
		closedir($dh);
	}
}
else
{
	$EVM->notify("Directory of plugins no found",E_USER_ERROR);
	//ERREUR LE TABLEAU n'as pu être crée on ferme l'application.
	echo "BAD EXEC DIRECTORY\n";
	exit(1);
}
$EVM->notify("Tableau d'execution: OK",E_USER_NOTICE);

// Installation des gestionnaires de signaux
$EVM->notify("GESTIONNAIRE DE SIGNAUX: ARMEMENT",E_USER_NOTICE);
pcntl_signal(SIGTERM, "sig_handler");
pcntl_signal(SIGINT, "sig_handler");

$EVM->notify("GESTIONNAIRE DE SIGNAUX: OK",E_USER_NOTICE);

try{
	//Threaded::extend(WSSocket::class);
	$EVM->notify("ECAPT - CONNECTION",E_USER_NOTICE);
	$ECATP = new ECATP($CONNECT,$SSL);
	if(isset($options["D"]))
	{
		$ECATP->DebugMode(true);
	}
	if(isset($options["D"]))
	{
		$ECATP->DebugMode(true);
	}
	$ECATP->setExecCallBackFunction("Execreceive");
	$EVM->notify("ECAPT - CONNECTION SUCCESS ",E_USER_NOTICE);
	
	$EVM->notify("ECAPT - REGISTER SEND $SN",E_USER_NOTICE);
	$ECATP->sendRegister($SN);
	$EVM->notify("ECAPT - REGISTER SUCCESS $SN",E_USER_NOTICE);
	
	//pointeur de fonction pour collecter les taches déjà exécutée.
	$fct = function($work )
	{
		//pas moyen de lui passé une propriété de la classe. Donc on fait directement référence à la GLOBAL.
		global $ECATP;
		global $EVM;
		$EVM->notify("SEND EXEC: ".$work->getTaskID()." ".$work->getExecutionStatus(),E_USER_NOTICE); 
		if($work->getExecutionStatus() != Task::TASK_FINISH_EXEC && $work->getExecutionStatus() != Task::TASK_PENDING_EXEC)
		{
			$taskid = $work->getTaskID();
			$return = $work->getReturnCode();
			/*$taskid = $work->getTaskID();
			$output = $work->getOutput();
			$return = $work->getReturnCode();
			$status = $work->getExecutionStatus();*/
			//on envoit le résultat
			$EVM->notify("SEND EXEC-RESPONSE: $taskid $return",E_USER_NOTICE);
			$ECATP->sendExecResponse($work);
			$work->setExecutionStatus(Task::TASK_FINISH_EXEC);
		}
		return $work->isGarbage();
	};
	
	//création des 2 pools
	$PoolMonitoringThread = new PoolThread('MONITOR',1,PoolThread::AUTOSIZE,$fct);
	$PoolWebThread = new PoolThread('WEB',1,PoolThread::AUTOSIZE,$fct);
		
	$EVM->notify("ECAPT - POOL CREATE SUCCESS ",E_USER_NOTICE);
	
	//Thread Alive
	$thAlive = new ThAlive($ECATP);
	$thAlive->start();
	
	$EVM->notify("ECAPT - THREAD ALIVE START ",E_USER_NOTICE);
	
	while($ENDCLIENT==0)
	{
		$return = $ECATP->receive();
	//	$EVM->notify("ECAPT - RCV: ".$return,E_USER_NOTICE);
		//$socket->receive("receive");
		//echo "END : $return $ENDCLIENT\n";
		
		time_nanosleep(0, 100000000); //0.1 secondes
		
		$PoolMonitoringThread->collectTask();
		$PoolWebThread->collectTask();
	}
	$thAlive->Terminated();
	$thAlive->join();
	$EVM->notify("ECAPT - ARRET",E_USER_NOTICE);
	$ECATP->close("receive");
}
catch(ECATPException $ex)
{
	$EVM->notify($ex,E_USER_ERROR);
	if($ex->getCode()==4)
	{
		$ECATP = null;
	}
}
catch(Exception $ex)
{
	$EVM->notify($ex,E_USER_ERROR);
	//printf("Error %d : %s\n",$ex->getCode(),$ex->getMessage());
}
exit(0);
/**
 * @brief Affiche l'aide du client
 */
function print_help()
{
	echo "example: gesa_client.php -f [config_file] -U [uri] -D \n";
	
	echo "\t -f [config_file] Fichier de configuration\n";
	echo "\t -U [uri]         Url de connexion de la websocket\n";
	echo "\t -D               Active le mode de DEBUG\n";
	
}
/**
 * @brief fonction de callback EXEC
 * @detail fonction exécutée par ECATP lorsque l'on reçoit une demande de type EXEC
 * 			La fonction vérifie que le plugin demandé existe bien et crée une tache qui sera exécutée par l'un ou l'autre Pool de thread
 * 			Si priority == 3 alors PoolWeb
 * 			Si priority > 3 alors PoolMonitoring.
 * @param integer $taskid identifiant de la tache
 * @param string $name nom du plugin
 * @param string $parameter paramètre d'execution
 * @param integer $priority priorité d'exécution
 */
function Execreceive($taskid,$name,$parameter,$priority)
{
	global $ECATP;
	global $EVM;
	global $EXEC_ARRAY;
	global $PoolWebThread;
	global $PoolMonitoringThread;
	$EVM->notify("TASK RCV: $taskid $name $parameter $priority",E_USER_NOTICE);
	file_put_contents('/tmp/last_exec_plugin',time(),LOCK_EX);

	$task = new Task($taskid, $name,$parameter,$priority,$ECATP);
	if(array_key_exists($name, $EXEC_ARRAY))
	{
		//echo "$id : EXEC: $path\n";
		$task->setCommand($EXEC_ARRAY[$name]);
	}
	else
	{
		$task->setCommand(null);
	}
	
	//$taskexec = new TaskExecute($EXEC_ARRAY,$task);
	if($task->getPriority() ==3 )
	{
		$PoolWebThread->submitTask($task);
		$EVM->notify("TASK SUBMIT WEB SIZE: ".$PoolWebThread->getPoolSize(),E_USER_NOTICE);
	}
	else
	{
		$PoolMonitoringThread->submitTask($task);
		$EVM->notify("TASK SUBMIT MONITOR SIZE: ".$PoolMonitoringThread->getPoolSize(),E_USER_NOTICE);
	}
}
/**
 * @brief gestionnaire de signaux système
 * @param integer $signo l'ID du signal reçu
 */
function sig_handler($signo)
{
	global $EVM;
	global $ENDCLIENT;
	echo $signo;
	$EVM->notify("SIG-HANDLER signal reçu: $signo",E_USER_NOTICE);
	switch ($signo) {
		case SIGTERM:
			$EVM->notify("SIG-HANDLER SIGTERM: ECATP STOP",E_USER_NOTICE);
			$ENDCLIENT=1;
			break;
		case SIGINT:
			$EVM->notify("SIG-HANDLER SIGINT: ECATP STOP",E_USER_NOTICE );
			$ENDCLIENT=1;;
			break;
		default:
			// gestion des autres signaux
	}
}
function getGESASN()
{
	$serialnumber = null;
	if(is_file(GESA_SN))
	{
		//on ouvre le fichier
		$file = fopen(GESA_SN, 'r');
		
		while (($buffer = fgets($file, 4096)) !== false) {
			$serialnumber.=$buffer;
		}
		//echo GESA_SN." $serialnumber\n";
		fclose($file);
	}
	return trim($serialnumber);
}
?>
